/*******************************************************************************
  MPLAB Harmony Application Source File
  
  Company:
    Microchip Technology Inc.
  
  File Name:
    app.c

  Summary:
    This file contains the source code for the MPLAB Harmony application.

  Description:
    This file contains the source code for the MPLAB Harmony application.  It 
    implements the logic of the application's state machine and it may call 
    API routines of other MPLAB Harmony modules in the system, such as drivers,
    system services, and middleware.  However, it does not call any of the
    system interfaces (such as the "Initialize" and "Tasks" functions) of any of
    the modules in the system or make any assumptions about when those functions
    are called.  That is the responsibility of the configuration-specific system
    files.
 *******************************************************************************/

// DOM-IGNORE-BEGIN
/*******************************************************************************
Copyright (c) 2013-2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 *******************************************************************************/
// DOM-IGNORE-END


// *****************************************************************************
// *****************************************************************************
// Section: Included Files 
// *****************************************************************************
// *****************************************************************************

#include <proc/p32mz2048efh100.h>

#include "app.h"

#include "mrx_VS1063.h"


#include "stdio.h"

char Buf[32];
int delay_Clock = 200000000;

APP_DATA     appData;
SYS_FS_HANDLE ys_fileHandle;
bool Flag_SdConnected; 

static DISK_FILE_NODE rootNode;
static DISK_FILE_PATH FilesTable[DISK_MAX_FILES];
SYS_FS_FSTAT ys_dirstat;
SYS_FS_HANDLE ys_dirHandle;

APP_DATA appData;
char str_FileName[64];  //t@C
unsigned char FileBuf[512];
size_t Num_Read;
int totalFiles;
int Num_File; 
const char *fname;
int ysNum0;

bool Flag_Pause;    //tꎞ~tO
bool Flag_Skip;     //tȃXLbvtO
bool Flag_Record;      //^Jn/~tO
bool Flag_PlayBack_RecFile; //^t@CĐ
bool Flag_RecFinalize;  //^I

bool PatcheUse;     //VS1063aGR[_pb`@gpFtrue@gpFfalse

char RecordFileName[] = "myVoice001.mp3";
//char RecordFileName[] = "myVoice001.wav";
char str_FileName[64];  //t@C

unsigned char recBuf[8192];
unsigned char *rbp;

unsigned int fileSize = 0;
int ysRet;
int wordNum;
unsigned short int val;
unsigned int ChunkSize;      //fileSize - 8
unsigned int SubChunk3Size;  //fileSize - 48

SYS_FS_RESULT res; 

//֐̃vg^Cv錾
void delay_ms(volatile unsigned int msec);
bool ys_FileType83(char *myFileName);
SYS_FS_RESULT DISK_FS_ReadDirFlat(char *lfname, uint8_t *dir_count, SYS_FS_FSTAT * dir_table, bool isRoot);
void DISK_TraverseAllFiles(DISK_FILE_NODE node, bool isRoot,uint8_t depth);





void delay_us(volatile unsigned int usec)        //1secx
{
        volatile  int count;

        count = (int)(delay_Clock/20000000)*usec;


        do      //@at@200MH (Clock=200000000)
        {       //delay_us(1000)F1000.4sec  delay_us(100)F100.6sec  delay_us(10):10.5sec@@delay_us(1)F1.5sec
                asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP");asm("NOP");
                asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP");

                count--;
        }while(count != 0);
}



void delay_ms(volatile unsigned int msec)        //1msecx
{
        volatile unsigned int i;         //Fat200MH (Clock=200000000)//delay_ms(1)F 1.0006msec   delay_ms(100)F100.04msec

        for(i=0; i<msec; i++)
        delay_us(1000);
}


void Write_Byte(char chr)  //1oCgM֐
{
    PLIB_USART_TransmitterByteSend(USART_ID_4, chr); //Mobt@[1oCg݁EM   
//    U4TXREG = chr;  ////Mobt@[1oCg݁EM 


    while (!PLIB_USART_TransmitterIsEmpty(USART_ID_4));  //Mobt@[ɂȂ܂ő҂
//while(!U4STAbits.TRMT);   //Mobt@[ɂȂ܂ő҂

}

void WriteString(const char *str)   //񑗐M֐
{
    while(*str)
    {
        Write_Byte(*str);   //f[^M
        str++;
    }
}


void SwCheckA(void)  //SW NbNo
{
    if(Flag_SdConnected == true)
    { 
        if(PORTAbits.RA4 == 0)  //tꎞ~/tĊJ
        {
            delay_ms(20);
            if(PORTAbits.RA4 == 0)
            {
                if(Flag_Pause == 0)Flag_Pause = 1;  //tꎞ~   
                else  Flag_Pause = 0;               //tĊJ
            }
        }

    }
}


void SwCheckB(void)  //SW NbNo
{
    if(Flag_SdConnected == true)
    { 
        if(PORTBbits.RB8 == 0)  //^Jn/~
        {
            delay_ms(20);
            if(PORTBbits.RB8 == 0)
            {
                if(Flag_Record == 0)
                {
                    Flag_Record = 1;  //^Jn
                    LATCbits.LATC14 = 1;
                   
                }   
                else
                {
                    Flag_Record = 0;               //^~
                    LATCbits.LATC14 = 0;
                    
                }
            }
        }
         
        if(PORTBbits.RB14 == 0) //^t@CփWv
        {
            delay_ms(20);
            if(PORTBbits.RB14 == 0)
            {
                if(Flag_PlayBack_RecFile == 0)
                {
                    Flag_PlayBack_RecFile = 1;    //^t@CĐ
                }
                else
                {
                    Flag_PlayBack_RecFile = 0;    //^t@CĐ
                }
            }
        }
    }
}


void SwCheckG(void)  //SW NbNo
{
    if(Flag_SdConnected == true)
    { 
       
        if(PORTGbits.RG15 == 0) //tȃXLbv
        {
            delay_ms(20);
            if(PORTGbits.RG15 == 0)
            {
                Flag_Skip = 1;    //tȃXLbv
                
            }
        }
 
    }
}



void APP_SYSFSEventHandler(SYS_FS_EVENT event, void * eventData, uintptr_t context) //SDJ[h̃}EgL𒲂ׂR[obN֐
{
    switch(event)
    {
        /* If the event is mount then check which media has been mounted */
        case SYS_FS_EVENT_MOUNT: 
            if(0 == strcmp((const char *)eventData,"/mnt/myDrive1"))
            {
                Flag_SdConnected = true;
            }

            break;
        /* If the event is unmount then check which media has been unmount */
        case SYS_FS_EVENT_UNMOUNT:
            if(0 == strcmp((const char *)eventData,"/mnt/myDrive1"))
            {
                Flag_SdConnected = false;
            }

            break;
            
        case SYS_FS_EVENT_ERROR:
            break; 
            
        default:
            break;
    }
}



bool ys_FileType83(char *myFileName)   //8.3`t@C`FbN //8.3`Ȃtrue
{
    bool Flag;
    
    if(myFileName[6] != 0x7E) Flag = true;    //~܂܂Ȃ@@8.3`t@C 
    else Flag = false;              //~܂܂@@Ot@C      //FMOONRI~1.mp3 
    
    return Flag;
}




//t@CXg쐬
SYS_FS_RESULT DISK_FS_ReadDirFlat(char *lfname, uint8_t *dir_count, SYS_FS_FSTAT * dir_table, bool isRoot)
{
    SYS_FS_RESULT ret;
    bool Flag83;
    char longFileName[300];
    
    ys_dirHandle = SYS_FS_DirOpen(lfname);  //lfname: tpX̃fBNg  //[gfBNg0
    
    if(ys_dirHandle == SYS_FS_HANDLE_INVALID)
    {
        return SYS_FS_RES_FAILURE;
    }
    *dir_count = 0;
    
    //do [vŁ@g[^̃t@CJEgB
    do
     {
         if(totalFiles < DISK_MAX_FILES)   //DISK_MAX_FILES = 80
         {
             ys_dirstat.lfname = longFileName;
             ys_dirstat.lfsize = 300;
             
             ret = SYS_FS_DirRead(ys_dirHandle,&ys_dirstat);   //fBNgEt@C̃Xe[^Xǂݍ
                                                                //ǂݍxɁ@قȂfBNgort@Cǂݍ
                                                                //͍\SYS_FS_FSTAT̃IuWFNgys_dirstatɂ
             if ((ys_dirstat.lfname[0] == '\0') && (ys_dirstat.fname[0] == '\0'))   //fBNg̏I[ɒBꍇAŔ
             {
                 break;
             }
             if(ret!= SYS_FS_RES_FAILURE)   //ǂݍݐȂ
             {

                 if(ys_dirstat.fattrib != SYS_FS_ATTR_DIR)    // fBNgłȂꍇ  //SYS_FS_ATTR_DIR: fBNg
                 {
                        Flag83 = ys_FileType83(ys_dirstat.fname);
                        // 8.3`t@C̏ꍇ
                        if(Flag83 == true)      
                        {
                            strcpy(FilesTable[totalFiles].path, lfname);    //t@Cfname FilesTable[totalFiles].pathɃRs[
                        
                            if(!isRoot) //[głȂꍇ
                            {
                                strcat(FilesTable[totalFiles].path, "/");  //pX̖ / ǉ
                            }
                            strcat(FilesTable[totalFiles].path, ys_dirstat.fname);
                        
                            (totalFiles)++;
                            
                            
                        }
                        // Ot@C̃t@C̏ꍇ
                        else if(Flag83 != true)   
                        {
                            strcpy(FilesTable[totalFiles].path, lfname); //t@Cfname FilesTable[totalFiles].pathɃRs[
                        
                            if(!isRoot) //[głȂꍇ
                            {
                                strcat(FilesTable[totalFiles].path, "/");  //pX̖ / ǉ
                            }
                            strcat(FilesTable[totalFiles].path, ys_dirstat.lfname);
                        
                            (totalFiles)++;    
                          
                        } 
                     
                    }
                    // fBNg̏ꍇ
                    else if(ys_dirstat.fattrib == SYS_FS_ATTR_DIR && ys_dirstat.fname[0] != '.') // Skip ".\" and "..\" directories
                    {
                            
                            if(*dir_count < DISK_MAX_DIRS)
                            {
                                dir_table[*dir_count]= ys_dirstat;
                                (*dir_count)++;
                            }
                    }
                
            }
            else
            {
                ret = SYS_FS_RES_FAILURE;
                break;
            }
        }
    }while(ret==SYS_FS_RES_SUCCESS);
     
    SYS_FS_DirClose(ys_dirHandle);
    return ret;    

}



void DISK_TraverseAllFiles(DISK_FILE_NODE node, bool isRoot,uint8_t depth)  //St@Cڍג֐    //ċA֐
{ 
     if(depth > TRAVERSE_DEPTH)     //fBNg̍ő[    //5
     {
         return;
     }
     int i;
     SYS_FS_RESULT ret;

     uint8_t totalDir = 0;
     SYS_FS_FSTAT dirTable[DISK_MAX_DIRS];
     
     ret = DISK_FS_ReadDirFlat(node.path, &totalDir, dirTable, isRoot);     //

     if(ret == SYS_FS_RES_FAILURE)
     {
         return;
     }

     DISK_FILE_NODE child_node;
     
     for(i = 0; i < totalDir; i++)
     {
         
         child_node.fstat = dirTable[i];
         
         strcpy(child_node.path, node.path);
         if(!isRoot)
         {
             strcat(child_node.path, "/");
         }
    
         strcat(child_node.path, child_node.fstat.fname);
         
    //-----̂ŌĂ΂Ă
         DISK_TraverseAllFiles(child_node, false, depth+1); //ċA
         
     }
     
     return;
 }


void APP_SdTasks ( void )
{
    int i;
    
    switch ( appData.state )
    {
            
        case APP_DISK_SCANNING:   //XLs

            
            DISK_TraverseAllFiles(rootNode, true, 0);   //[gSt@Cڍׂɒ   //ċA֐
            
            if(totalFiles == 0)
            {
             
                // No File
                appData.state = APP_DISK_SCANNING;
            }
            else
            {    
                lcd_cmd(0x80);          //1ڂ̐擪
                sprintf(Buf,"TotalFile=%d              ", (totalFiles - 1));	//FilesTable[0].path́ASystem Volume Information
                lcd_str(Buf);           // JnbZ[W1sڕ\
                
                lcd_cmd(0xC0);          //2sڂ̐擪
                sprintf(Buf,"                            ");	//
                lcd_str(Buf);           // JnbZ[W1sڕ\
                
                //Tera TermɑSt@C\
                sprintf(Buf,"TotalFile=%d\r\n", (totalFiles - 1));
                WriteString(Buf);   
    
                delay_ms(2000);
                
                //Tera TermɑSt@C̃t@CtpXtŕ\
                
                for (i = 1; i < totalFiles; i++ )
                {
                    sprintf(Buf,"%s\r\n",FilesTable[i].path);
                    WriteString(Buf);
                }
                WriteString("\r\n"); 
                
               
                //St@C\@for LN^t@&@UART
//                for (i = 1; i < totalFiles; i++ )   //FilesTable[0].pathSystem Volume Information
//                {
//                    lcd_cmd(0x80);          //1ڂ̐擪
//                    sprintf(Buf,"%s               ", FilesTable[i].path);// 
//                    lcd_str(Buf);                   //t\
//                    
//                    lcd_cmd(0xC0);          //Qsڂ̐擪
//                    //̒ŕ\@𔻕
//                    if(strlen(FilesTable[i].path) <= 16)     //pXtt@C16ȓłꍇ
//                    {
//                        sprintf(Buf,"                 ");
//                        lcd_str(Buf);           // JnbZ[W1sڕ\
//                    }
//                    else
//                    {
//                        sprintf(Buf,"%s                 ", FilesTable[i].path + 16);	//FilesTable[i]̃|C^16oCgi߂
//                        lcd_str(Buf);           // JnbZ[W1sڕ\
//                    }
//                   delay_ms(1000);
//                }
                
                
                Num_File = 1;   //t@Ce[u No = 1 ݒ
                
                appData.state = APP_OPEN_FILE;
            }
            break;
            
                
        case APP_OPEN_FILE:     //t@CJĉt
                VS1063_Init();      //K{  //ȂƃmCY at Skip Mode
            
                if(Flag_PlayBack_RecFile == 1)
                {
                    Flag_PlayBack_RecFile = 0;
                    fname = "DIR_REC/myVoice001.mp3";
                }
                else
                {
                    fname = FilesTable[Num_File].path;  //pXtt@C擾
                }
                
                
                ys_fileHandle = SYS_FS_FileOpen(fname, (SYS_FS_FILE_OPEN_READ_PLUS));   //ǂݍ݃[hŁAt@CI[v

                if(ys_fileHandle == SYS_FS_HANDLE_INVALID)
                { //t@CI[vG[̏ꍇ
                    lcd_cmd(0x80);          //1ڂ̐擪
                    sprintf(Buf,"FileOpen failed          ");//
                    lcd_str(Buf);                   //t\
                    //while(1);
                }
                else
                {
                    lcd_cmd(0x80);          //1ڂ̐擪
                    sprintf(Buf,"%s               ", fname);// 
                    lcd_str(Buf);                   //t\
                    
                    lcd_cmd(0xC0);          //Qsڂ̐擪
                    //̒ŕ\@𔻕
                    if(strlen(fname) <= 16)     //pXtt@C16ȓłꍇ
                    {
                        sprintf(Buf,"                 ");
                        lcd_str(Buf);           // JnbZ[W1sڕ\
                    }
                    else
                    {
                        sprintf(Buf,"%s                 ", fname + 16);	//FilesTable[i]̃|C^16oCgi߂
                        lcd_str(Buf);           // JnbZ[W1sڕ\
                    }
                    
                   // Tera Term֑M
                    sprintf(Buf,"%s\r\n", fname);
                    WriteString(Buf); 
                  
                    appData.state = APP_SEND_DATA;
                }
            break;
   
            
        case APP_SEND_DATA:     //t@CJĉt 
            do{
                    if(Flag_Pause == 1)break;   //ꎞ~̏ꍇ
                    if(Flag_Record == 1)break;  //^̏ꍇ
                    if(Flag_PlayBack_RecFile == 1)break;    //^t@CĐ
                                                 
                    if((Flag_Skip == 1) || (Flag_PlayBack_RecFile == 1))      //XLbv̏ꍇ
                    {
                        Flag_Skip = 0;
                        appData.state = APP_NEXT_FILE;  
                        break;
                    }
                    
                    
                    PLIB_INT_SourceDisable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_A);  //Aportω荞݋֎~
                //    IEC3bits.CNAIE = 0;      //Aport ω荞݋֎~
                    
                    PLIB_INT_SourceDisable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);  //Gportω荞݋֎~
                //    IEC3bits.CNGIE = 0;      //Dport ω荞݋֎~
                    IEC0bits.T1IE = 0;  //VXe^C}荞݋֎~
                    
                    VS1063_XCS = 1;			// R}hM[h@OFF
                    while(!VS1063_DREQ);	// VS1053҂   // DREQ1ɂȂ܂ő҂
                    VS1063_DataSendOn();         // f[^M[h@ON
    
                    
                    Num_Read = SYS_FS_FileRead(ys_fileHandle, FileBuf, 512);    //t@CGh܂ŒBꍇ:@ǂݍݎsA-1Ԃ

                    for( i= 0; i<Num_Read; i++)VS1063_SendData(FileBuf[i]);	//tf[^VS1053 M
       
                    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_A);   //Aport ω荞ݗL                            
                //    IEC3bits.CNAIE = 1;  //Aport ω荞ݗL
                    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);   //Gport ω荞ݗL                            
                //    IEC3bits.CNGIE = 1;  //Dport ω荞ݗL
                    IEC0bits.T1IE = 1;    //VXe^C}荞ݍĊJ
                   
            	} while(Num_Read != 0); 
                
                VS1063_DataSendOff();         // f[^M[h@OFF
                
                if(Flag_Pause == 1)appData.state = APP_STATE_IDLE;
                else if(Flag_Record == 1)appData.state = APP_STATE_RECORD;
                //else if(Flag_PlayBack_RecFile ==1)appData.state = APP_OPEN_REC_FILE;
                else appData.state = APP_NEXT_FILE;
                
            break;
            
            
        case APP_NEXT_FILE:
                VS1063_ResetOn();//\tgEFAZbgs
                delay_ms(50);
                VS1063_ResetOff();
                delay_ms(50);
                    
                SYS_FS_FileClose(ys_fileHandle);
                Num_File++;
                if(Num_File >=  (totalFiles))Num_File = 1;
                appData.state = APP_OPEN_FILE;
            break;
    
            
            
/////////////////////////////////////////////////////////////////////////////////           
//  ^Xe[g         
/////////////////////////////////////////////////////////////////////////////////            
          case APP_STATE_RECORD:
                ys_fileHandle = SYS_FS_FileClose(ys_fileHandle);   //t@CN[Y
                if(ys_fileHandle != SYS_FS_HANDLE_INVALID)
                {
                    sprintf(Buf,"Fileclose succeeded !\r\n\r\n"); 
                    WriteString(Buf);       //TeraTerm
                }
             
                VS1063_ResetOn();//n[hEFAZbgs
                delay_ms(100);
                VS1063_ResetOff();
                delay_ms(100); 
                
                PatcheUse = true;     //VS1063aGR[_pb`@gpFtrue@gpFfalse    
                
                //VS1063_PcmRec_Init(PatcheUse);    //kȂ jAPCM(WAVEA*.wav)  
                //VS1063_ImaRec_Init(PatcheUse);    //kR[fbN IMA ADPCM(WAVEA*.wav) 
                VS1063_Mp3Rec_Init(PatcheUse) ;     //MP3R[fbN (*.mp3) 
                
                SYS_FS_RESULT resDir;
                //^pfBNg̍쐬
                resDir = SYS_FS_DirectoryMake("Dir_Rec");  //Dir_RecfBNgɑ݂Ăꍇ@
                                                            //resDirɂ́@SYS_FS_RES_FAILUREԂ邪@̌̓ɂ͉eȂB
                SYS_FS_DirectoryChange("Dir_Rec");


    
                res = SYS_FS_FileDirectoryRemove(RecordFileName);   //ȑȌݗpt@CcĂ폜B
                if(res == SYS_FS_RES_SUCCESS )LATFbits.LATF4 = 1;

                //݃[hŁAt@CI[vAt@C̐擪珑݊JnAṽt@C݂Ȃꍇ͐VKɃt@C쐬
                ys_fileHandle = SYS_FS_FileOpen(RecordFileName, (SYS_FS_FILE_OPEN_WRITE_PLUS )); 
                SYS_FS_FileSeek(ys_fileHandle, 0, SYS_FS_SEEK_SET); //t@C|C^擪Ɉړ

       
                if(ys_fileHandle != SYS_FS_HANDLE_INVALID)
                {
                    SYS_FS_FileNameGet(ys_fileHandle, str_FileName, 32 ); //t@C擾
                    sprintf(Buf,"%s Opened !\r\n ",str_FileName); 
                    WriteString(Buf);       //TeraTerm
                    sprintf(Buf,"Start Rcoding !\r\n "); 
                    WriteString(Buf);       //TeraTerm
                    
                }
                
                
                  VS1063_XCS = 1;               // R}hM[h@OFF
                  VS1063_XDCS = 0;              // f[^M[h@ON
                    
                rbp = &recBuf[0];
                
                do{ 
                    
                    if(Flag_Record == 0)   //^~
                    {
                        Flag_RecFinalize = 1;
                        break;
                    } 
                    
                    while(!VS1063_DREQ);		//VS1063̏҂
                
                    wordNum = mrxVS1063_ReadSci(SCI_HDAT1);  //obt@[ɂf[^16rbgf[^̐擾    //HDAT1WX^F0x9  
//                    sprintf(Buf,"wordNum=%d\r\n", wordNum);   //fobNpA
//                    WriteString(Buf);       //TeraTerm
                
                    
                    //wordNum = min(wordNum, 8192/2);
                    
                    PLIB_INT_SourceDisable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_A);  //Aportω荞݋֎~
                //    IEC3bits.CNAIE = 0;      //Aport ω荞݋֎~                    
                    PLIB_INT_SourceDisable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_B);  //Bportω荞݋֎~
                //    IEC3bits.CNBIE = 0;       //Bport ω݋֎~
                    PLIB_INT_SourceDisable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);  //Gportω荞݋֎~
                //    IEC3bits.CNGIE = 0;      //Dport ω荞݋֎~
                    IEC0bits.T1IE = 0;  //VXe^C}荞݋֎~
                    
                    
                    for (i=0; i< wordNum; i++)
                    {
                        while(!VS1063_DREQ);		//VS1063̏҂
                        val = mrxVS1063_ReadSci(SCI_HDAT0);	//P16bit f[^擾    //SCI_HDAT0WX^(0x08)
//                        sprintf(Buf,"val=0x%X\r\n", val);         //fobNpA^\ɉe             
//                        WriteString(Buf);       //TeraTerm
                 
                        *rbp++ = (unsigned char)(val >> 8);
                        *rbp++ = (unsigned char)(val & 0xFF);
                    }
                     ysRet = SYS_FS_FileWrite(ys_fileHandle, &recBuf[0], 2*wordNum);//2 x wordNumoCg: recBufɂl(2 x wordNum)oCgt@C̖ɒǋL
//                     sprintf(Buf,"ysRet=%d\r\n", ysRet);          //fobNp@^\ɉe
//                     WriteString(Buf);       //TeraTerm
                     fileSize += 2*wordNum;     //ǉf[^ioCgjt@CTCYɉZ
                     
                    rbp = &recBuf[0];   //obt@NA
                    
                    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_A);   //Aport ω荞ݗL                            
                    //IEC3bits.CNAIE = 1;  //Aport ω荞ݗL
                    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_B);   //Bport ω荞ݗL 
                    //IEC3bits.CNBIE = 1;   //Bport ωݗL    
                    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);   //Gport ω荞ݗL                            
                    //IEC3bits.CNGIE = 1;  //Dport ω荞ݗL
                    IEC0bits.T1IE = 1;    //VXe^C}荞ݍĊJ
                    
                  }while(fileSize < 100000000);  //MAX 100MoCg   //^őt@CTCY𐧌
                    Flag_RecFinalize = 1;
                    
                    if(Flag_RecFinalize == 1)   //^I
                    {
                        LATCbits.LATC14 = 0; 
                        
                        while(!VS1063_DREQ);	// VS1053҂   // DREQ1ɂȂ܂ő҂
                        mrxVS1063_WriteSci(SCI_MODE, mrxVS1063_ReadSci(SCI_MODE) | SM_CANCEL);    //VS1063_WriteSci(SCI_MODE, SM_SDINEW | SM_CANCEL);    //SM_CANCEL: 0x0008
                                           
                        delay_ms(500);

                        //t@C̏ꍇɕύXKv
                        unsigned short int value0 = mrxVS1063_ReadWram(0x1e06);	//RAḾ@0x1e06AhXɂlǂݏo //#define PAR_END_FILL_BYTE 0x1e06
                        if (value0 & 0x8000)
                        {
                            unsigned char temp1 = value0 & 0xFF;
                            SYS_FS_FileWrite(ys_fileHandle, &temp1, 1); //t@C1oCgǉ
                        }
                        
                          //WAVE/RFFt@Ĉ
//                        //t@Cwb_[Ƀ`N
//                        ChunkSize = fileSize - 8;  //ItZbg0x04ɏޒl
//                        sprintf(Buf,"fSize-8=0x%X\r\n", fileSize - 8); 
//                        WriteString(Buf);       //TeraTerm
//                        
//                        SYS_FS_FileSeek(ys_fileHandle, 4, SYS_FS_SEEK_SET); //t@C|C^̈ʒut@C擪4(0x04)oCgItZbgʒuɈړ
//                        SYS_FS_FileWrite(ys_fileHandle, &ChunkSize, 4);     // &ChunkSize̒l@4oCg
//                        
//                        SubChunk3Size = fileSize - 48;  //ItZbg0x2Cɏޒl    //TEhf[^̃TCY
//                        sprintf(Buf,"fSize-48=0x%X\r\n", fileSize - 48); 
//                        WriteString(Buf);       //TeraTerm
//                        SYS_FS_FileSeek(ys_fileHandle, 44, SYS_FS_SEEK_SET);    //t@C|C^̈ʒut@C擪44(0x2C)oCgItZbgʒuɈړ
//                        SYS_FS_FileWrite(ys_fileHandle, &SubChunk3Size, 4);     // &SubChunk3Size̒l@4oCg
                        
                        
                        
                                                   
                        ys_fileHandle = SYS_FS_FileClose(ys_fileHandle);
                        Flag_RecFinalize = 0; 
                            
                        if(ys_fileHandle != SYS_FS_HANDLE_INVALID)
                        {
                            sprintf(Buf,"fileSize=%d[byte]\r\n", fileSize); 
                            WriteString(Buf);       //TeraTerm
                            sprintf(Buf,"RecordFileClose succeeded\r\n"); 
                            WriteString(Buf);       //TeraTerm
                        }
                    }
                    else
                    {
                            sprintf(Buf,"fileSize > 10Mbyte\r\n"); 
                            WriteString(Buf);       //TeraTerm
                    }
                
                 
                    SYS_RESET_SoftwareReset();  //PIC\tgEFAZbg
                    
                  
                    
              break;

        
        
        case APP_STATE_IDLE:
            
            
            if(Flag_Pause == 0) 
            {
                VS1063_DataSendOn();         // f[^M[h@ON
                appData.state = APP_SEND_DATA;      //ꎞ~̏ꍇ
                break;
            }
             
                 
            if(Flag_SdConnected == false)  //SDJ[h𔲂
            {
                SYS_RESET_SoftwareReset();  //Zbg
            }

            break;


        default:
            break;
      }

}



/*******************************************************************************
  Function:
    void APP_Initialize ( void )

  Remarks:
    See prototype in app.h.
 */

void APP_Initialize ( void )
{
    /* Place the App state machine in its initial state. */
    appData.state = APP_STATE_INIT;

    
    /* TODO: Initialize your application's state machine and other
     * parameters.
     */
     
    //appData.state = APP_OPEN_FILE;
    //appData.state = APP_DISK_SCANNING;

    
//
////---------------------------------------------------------------------------------------------------------
////@MHCł͂ȂRG15́@CNݒ肷ƃoOł
////oO̓eFdONPIC32MZNȂBZbg{^NbNƋN    
//    #undef SYS_PORT_G_CNEN                  //system_config.hŒ`@"#define SYS_PORT_G_CNEN    0x0000h폜A
//    #define SYS_PORT_G_CNEN         0x8000  //RG15|[gɁ@CNǉ 
//    PLIB_PORTS_ChannelChangeNoticeEnable(PORTS_ID_0, PORT_CHANNEL_G, SYS_PORT_G_CNEN);  //G|[gɌWCNĒ`
//    
//    PLIB_PORTS_Read(PORTS_ID_0, PORT_CHANNEL_G);    
//    PLIB_INT_SourceFlagClear(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);         
//    PLIB_INT_SourceEnable(INT_ID_0, INT_SOURCE_CHANGE_NOTICE_G);
//    PLIB_INT_VectorPrioritySet(INT_ID_0, INT_VECTOR_CHANGE_NOTICE_G, INT_PRIORITY_LEVEL1);
//    PLIB_INT_VectorSubPrioritySet(INT_ID_0, INT_VECTOR_CHANGE_NOTICE_G, INT_SUBPRIORITY_LEVEL0);
////---------------------------------------------------------------------------------------------------------   
    
    lcd_init();				// LCD
    lcd_cmd(0b00001100);    // J[\:OFF  uݸ:OFF
    
    lcd_clear();            // S

    lcd_cmd(0x80);          //1sڂ̐擪
    sprintf(Buf,"VS1063a Encoding       ");   //t@C@//󔒕K{
    lcd_str(Buf);           // JnbZ[W1sڕ\
    lcd_cmd(0xC0);          //Qsڂ̐擪
    sprintf(Buf,"MP3 PCM ImaADPCM      ");	//^b`YW\
    lcd_str(Buf);           // JnbZ[W2sڕ\
                    
    delay_ms(2000);

    
    PLIB_SPI_Enable(SPI_ID_4);
    
   
    

    VS1063_Init();  //VS1063A
 
    //񑗐M
    WriteString("UART Connected !!\r\n");
   
 
    
     
}


/******************************************************************************
  Function:
    void APP_Tasks ( void )

  Remarks:
    See prototype in app.h.
 */

void APP_Tasks ( void )
{
    
    switch ( appData.state )
    {
        case APP_STATE_INIT:
            SYS_FS_EventHandlerSet(APP_SYSFSEventHandler, (uintptr_t)NULL);
            appData.state = APP_STATE_WAIT_FOR_DEVICE_ATTACH;
            break;
            
        case APP_STATE_WAIT_FOR_DEVICE_ATTACH:
            if(Flag_SdConnected == true)
            {
                appData.state = APP_DISK_SCANNING;
            }
            break;
    }

      
      APP_SdTasks();
            

}

 

/*******************************************************************************
 End of File
 */
